import java.net.*;
import java.io.*;
import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.rmi.*;
import java.rmi.server.*;

//ten program nalezy uruchomic jako drugi
public class RMI_Klient3 extends JFrame 
                     implements Runnable,ActionListener
{  RMI_Interfejs_Wiadomosci3 obiekt;
   int id;
   Wiadomosc3 m1=null;
   JTextField nazwa = new JTextField(20);
   JTextArea komentarz = new JTextArea (4,18);

 
 RMI_Klient3(String s)
  { super("Klient "+s);
    setSize(300,160);
   	setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
   	nazwa.addActionListener(this);
   	JPanel panel=new JPanel();
   	JLabel etykieta_nazwy = new JLabel ("Napisz");
    JLabel etykieta_komentarza = new JLabel  ("Rozmowa");
   	komentarz.setLineWrap(true);
   	komentarz.setWrapStyleWord(true);
   	panel.add(etykieta_nazwy);
   	panel.add(nazwa);
   	panel.add(etykieta_komentarza);   
   	komentarz.setText("");	
   	panel.add(komentarz);
   	JScrollPane obszar_przewijany1 = new JScrollPane
   	 (komentarz,
   	  ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS,
   	  ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
   	panel.add(obszar_przewijany1);
   	setContentPane(panel);  
   	try
    {
     obiekt= (RMI_Interfejs_Wiadomosci3)Naming.lookup("RMI_Wiadomosci");
     id=obiekt.zarejestruj(s);
     komentarz.setText("Klient startuje na hoscie "+ 
   	           InetAddress.getLocalHost().getHostName()+"\n");  
   	 m1=new Wiadomosc3();
   	 m1.id=id;
   	 m1.dane="Poczatek";             
    }
    catch(Exception e)
     {System.out.println("Wyjatek klienta2 1 "+e);     } 
   	setVisible(true);
      
  }
   public void actionPerformed(ActionEvent evt)
   {Object zrodlo = evt.getSource();
      if(zrodlo==nazwa && m1!=null) //m1!=null oznacza poprawne poaczenie z obiektem RMI
       { m1.dane=nazwa.getText();
         nazwa.setText("");
          try
           {obiekt.writeObject(m1);       
           }
           catch(Exception e)
            {System.out.println("Wyjatek klienta2 2"+e);} 
       }
      repaint(); 
   }
   
 public void run()
   { Wiadomosc3 m=null;
   	while(m1!=null &&!m1.dane.equals("czesc"))//wylaczenie klienta z odbioru
   	{
   	try
	  {
	   m=obiekt.readObject(id);	    
      }catch (Exception e)	
     {System.out.println("Wyjatek klienta2 3"+e);}
      if(m!=null ) 
	        {String s=komentarz.getText();
	         komentarz.setText(s+"Dane odebrane od serwera: "+m.dane+"\n");}    
    }
   } 
  
  public static void main(String args[]) throws Exception
	{System.setSecurityManager(new RMISecurityManager());
	 RMI_Klient3 k2= new RMI_Klient3(args[0]);
	 Thread t = new Thread(k2);
	 t.start();
	}  
}