import java.rmi.*;
import java.rmi.server.*;
import java.net.*;
import java.io.*;
import javax.swing.*;
import java.awt.event.*;
import java.awt.*;

class RMI_server_komp3 extends JFrame implements Runnable, 
                                     ActionListener
{  
  Wiadomosc3 w=null;
  JTextField nazwa = new JTextField(20);
  JTextArea komentarz = new JTextArea (4,18);

 public RMI_server_komp3(String s)
  { super("Komponent serwera "+s);
    setSize(300,160);
    nazwa.addActionListener(this);
   	setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
   	JPanel panel=new JPanel();
   	JLabel etykieta_nazwy = new JLabel ("Napisz");
    JLabel etykieta_komentarza = new JLabel  ("Rozmowa");
   	komentarz.setLineWrap(true);
   	komentarz.setWrapStyleWord(true);
   	panel.add(etykieta_nazwy);
   	panel.add(nazwa);
   	panel.add(etykieta_komentarza); 
   	komentarz.setText("");  	
   	panel.add(komentarz);
   	JScrollPane obszar_przewijany1 = new JScrollPane
   	 (komentarz,
   	  ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS,
   	  ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
   	panel.add(obszar_przewijany1);
   	setContentPane(panel);
   	setVisible(true);    
  }
 
  public void actionPerformed( ActionEvent evt)
   {Object zrodlo = evt.getSource();
    w=null;
      if(zrodlo==nazwa && !nazwa.getText().equals("")) 
       { 
         w=new Wiadomosc3();
         w.dane=nazwa.getText();
         nazwa.setText("");
       }
      repaint(); 
   }
   
public void run()
   {String pom;
   	try
     {komentarz.setText("RMI komponent serwera startuje na hoscie "+ 
   	           InetAddress.getLocalHost().getHostName()+"\n"); 
     }catch (Exception e)
	   {System.out.println("Wyjatek serwera2 "+e);}
   }
}


public class RMI_Server3
 { public static void main(String[] args)
    { System.setSecurityManager(new RMISecurityManager());
      try
      {         
        RMI_Wiadomosci3 obiekt = new RMI_Wiadomosci3();
        Naming.rebind("RMI_Wiadomosci", obiekt);
        System.out.println("Sewer przygotowany do RMI");
      }
      catch (Exception	e)
      {System.out.println("Blad "+e);
      }
 
    } 
 }