import java.io.*;
import java.rmi.*;
import java.rmi.server.*;
import java.util.*; 
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class RMI_Wiadomosci3 extends UnicastRemoteObject
                     implements RMI_Interfejs_Wiadomosci3                                       
 {  
   Vector <RMI_server_komp3>klienci=
     new Vector<RMI_server_komp3>();
   
   RMI_Wiadomosci3() throws RemoteException
    {
    }
    
   public int zarejestruj(String s)throws RemoteException
    { RMI_server_komp3 komp=new RMI_server_komp3(s);
      Thread t=new Thread(komp);
      t.start();
      klienci.add(komp);  
      return klienci.indexOf(komp);   
    }
  
   public void writeObject(Wiadomosc3 w)throws RemoteException
    {String s;         
     RMI_server_komp3 pom=(RMI_server_komp3)klienci.get(w.id); //pom-odbiorca po stronie serwera
     if (pom!=null)
         {s=pom.komentarz.getText();  
	      pom.komentarz.setText(s+"Odebrano wiadomosc od klienta: "+ w.dane +"\n"); 
	     }
     }
   
   public Wiadomosc3 readObject(int id)throws RemoteException
    { RMI_server_komp3 pom=(RMI_server_komp3)klienci.get(id);//pom-nadawca po stronie serwera
      if (pom!=null && pom.w!=null) //pom.w==null oznacza brak wiadomosci do wyslania przez nadawce pom postrnie serwera
          {  
            Wiadomosc3 w=pom.w;
            pom.w=null;//skasowanie odczytanej wiadomosci u nadawcy po stronie serwera-gotowosc do nadanie nastepnej wiadomosci
            return w;  //wyslanie wiadomosci przez nadawce po stronie serwera      
	      }
	  else return null;
    }
 }

 