package examples.rmisocfac;
import java.rmi.*;
import java.rmi.registry.*; 
import java.io.*;
import java.util.*;

public class RMI_Klient implements Runnable
{ RMI_Interfejs_Wiadomosc wiadomosc;

  void Zapiszobiektydopliku(String s) throws RemoteException
     {System.out.println(s); 
      try
      { FileOutputStream plikobiektow = 
      	 new FileOutputStream ("Wiadomosc.obj");
      	ObjectOutputStream  strumienobiektow = 
      	   new 	ObjectOutputStream (plikobiektow);
        strumienobiektow.writeObject(wiadomosc);
        strumienobiektow.close();
        System.out.println(
        	"\nObiekt wiadomosc zostal zapisany do pliku");
         }catch (Exception e)
        { System.out.println ("Blad zapisu pliku obiektowego"+e);}  
    }
  
   void Odczytajobiektyzpliku(String s)throws RemoteException
    {
      try
      { FileInputStream plikobiektow = 
      	 new FileInputStream ("Wiadomosc.obj");
      	ObjectInputStream  strumienobiektow = 
      	   new 	ObjectInputStream (plikobiektow);
        RMI_Interfejs_Wiadomosc wiadomosc_nowa =(RMI_Interfejs_Wiadomosc)strumienobiektow.readObject();
        System.out.println("\nObiekt wiadomosc zostal odczytany z pliku");
        if (wiadomosc_nowa!=null)
          wiadomosc_nowa.odczytajWiadomosc(s);
        strumienobiektow.close();
      }catch (Exception e)
        { System.out.println ("Blad odczytu pliku obiektowego"+e);        }  
    }
  public void run()
   {
   	System.setSecurityManager(new RMISecurityManager());
    try
     { 
       Registry registry = LocateRegistry.getRegistry(5002);
       wiadomosc  = (RMI_Interfejs_Wiadomosc)
                            registry.lookup("RMI_Wiadomosc");
       System.out.println("Klient przygotowany do RMI");
       wiadomosc.zapiszWiadomosc("\nKlient uzywa metody zapiszWiadomosc obiektu z serwera za pomoca RMI" );
       Date data=wiadomosc.odczytajWiadomosc("\nKlient uzywa metody odczytajWiadomosc obiektu z serwera za pomoca RMI");
       System.out.println("Data otrzymana z serwera: "+data);       
       Zapiszobiektydopliku("\nKlient zapisuje do pliku obiekt z serwera dostepny za pomoca RMI"); 
       Odczytajobiektyzpliku("\nTo zawartosc obiektu odczytana przez klienta z pliku za pomoca serializacji");                              
     }
     catch (Exception e)
      {System.out.println("Blad klienta RMI: "+e.getMessage());
       e.printStackTrace();}
   }
   
   
   public static void main(String []args)
   { RMI_Klient klient = new  RMI_Klient();
   	 Thread t=new Thread(klient);    
   	 t.start();
   }
}