package examples.rmisocfac;
import java.io.*;
import java.rmi.*;
import java.rmi.server.*;
import java.rmi.registry.*; 

public class RMI_Server
 { public static void main(String[] args)
    { System.setSecurityManager(new RMISecurityManager());
      try
      { byte pattern = (byte) 0xAC;
        RMIClientSocketFactory RMIcsf = new XorClientSocketFactory(pattern);
	    RMIServerSocketFactory RMIssf = new XorServerSocketFactory(pattern);
        RMI_Wiadomosc wiadomosc = new RMI_Wiadomosc();
        
        RMI_Interfejs_Wiadomosc stub =
		(RMI_Interfejs_Wiadomosc)UnicastRemoteObject.exportObject(wiadomosc, 0, RMIcsf, RMIssf);
        //Utworzenie rejestru i zrejestrowanie referencji do zdalengo obiektu.
	    LocateRegistry.createRegistry(5002);
	    Registry registry = LocateRegistry.getRegistry(5002);	
	    registry.rebind("RMI_Wiadomosc", stub);
        System.out.println("Sewer przygotowany do RMI");
      }
      catch (Exception	e)
      { System.out.println("Blad serwera RMI"+e.getMessage());
        e.printStackTrace();
      }
 
    } 
 }